package daobeauty.dao;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import org.hibernate.Criteria;
import org.hibernate.Query;


/**
 * Created 18.04.2008
 * @author M. Serhat Cinar
 *
 */
public interface Dao extends SessionFactoryAware{
	public Class getDomain();
	public Serializable getPrimaryKey();
	public Object findByPrimaryKey(Serializable id);
	
	// crud
	public void saveOrUpdate(Object d);
	public void saveOrUpdate(Collection d);
	public void save(Object d);
	public void save(Collection d);
	public void update(Object d);
	public void update(Collection d);
	public void delete(Object d);
	public void delete(Collection d);
	
//	public List getAll(int offset, int amount);
//	public List getAll(int offset, int amount, String orderBy, boolean asc);
	public Query getNamedQuery(String name);
	public List findByExample(Object example);
	public long findCountByExample(Object example);
	public Criteria createCriteria();
	/*
	 *  Book .findByTitleLike("Harry Pot%") 
	 *  results = Book .findByReleaseDateBetween( firstDate, secondDate ) 
	 *  results = Book .findByReleaseDateGreaterThan( someDate ) 
	 *  results = Book .findByTitleLikeOrReleaseDateLessThan( "%Something%", someDate )
		results = Book.findAllByAuthor( Author.get(1) )
	 * */
	/*
	 * def results =
      Book.findAll("from Book as b where b.title like 'Lord of the%'")

Or with positional parameters:

def results =
      Book.findAll("from Book as b where b.title like ?", ["The Shi%"])

Or with named parameters:

def results =
      Book.findAll("from Book as b where b.title like :search or b.author like :search", [search:"The Shi%"])
       Book
   .findAllByAuthor( Author.get(1), [sort:'title',order:'asc'] )
	 * */
	public List findAll();
	public List findAll(String hqlQuery, Object[] values);
	public long findCountAll(String hqlQuery, Object[] values);
	public List findAll(String hqlQuery, Map valuesByName);
	public List findCountAll(String hqlQuery, Map valuesByName);
	public List findAll(String hqlQuery);
	public List findCountAll(String hqlQuery);
	
}