package daobeauty.interceptor.parser;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.NoSuchElementException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * Created 15.09.2008
 * @author M. Serhat Cinar
 *
 */
public class Stack<O> {
	@SuppressWarnings("unused")
	private static final Log LOG = LogFactory.getLog(Stack.class);
	
	private final LinkedList<O> stack = new LinkedList<O>();
	
	public void push(O element){
		stack.add(element);
	}
	
	public O pop(){
		if (stack.isEmpty()){
			throw new NoSuchElementException();
		}
		final O last = stack.removeLast();
		return last;
	}
	
	public O peek(){
		if (stack.isEmpty()){
			throw new NoSuchElementException();
		}
		final O last = stack.getLast();
		return last;
	}
	
	public boolean isEmpty(){
		return stack.isEmpty();
	}
	
	public void addFirst(O element){
		stack.addFirst(element);
	}
	
	public int size(){
		return stack.size();
	}
	
	public Iterator<O> iterator(){
		return stack.iterator();
	}
	
	public String toString(){
		final StringBuilder sb = new StringBuilder();
		sb.append("["+stack.size()+"]{");
		final Iterator<O> iter = iterator();
		while (iter.hasNext()){
			sb.append("\""+String.valueOf(iter.next())+"\"");
			if (iter.hasNext()){
				sb.append(", ");
			}
		}
		sb.append("}");
		return sb.toString();
	}
}
