package daobeauty.proxy;

import org.hibernate.SessionFactory;

import daobeauty.proxy.reflection.ReflectionProxyProvider;


/**
 * Created 08.09.2008
 * @author M. Serhat Cinar
 *
 */
public class ProxyFactory {
	private boolean useByteCodeProviderForInterfaces = false;
	private ProxyProvider byteCodeProvider;
	
	public ProxyFactory(){}
	
	public ProxyFactory(String byteCodeProvider){
		this.byteCodeProvider = ByteCodeProviders.getInstance(byteCodeProvider);
	}
	
	public ProxyFactory(ProxyProvider byteCodeProvider){
		this.byteCodeProvider = byteCodeProvider;
	}
	
	public ProxyFactory(boolean useByteCodeProviderForInterfaces){
		this.useByteCodeProviderForInterfaces = useByteCodeProviderForInterfaces; 
	}
	
	public ProxyFactory(String byteCodeProvider, boolean useByteCodeProviderForInterfaces){
		this.byteCodeProvider = ByteCodeProviders.getInstance(byteCodeProvider);
		this.useByteCodeProviderForInterfaces = useByteCodeProviderForInterfaces;
	}
	
	public ProxyFactory(ProxyProvider byteCodeProvider, boolean useByteCodeProviderForInterfaces){
		this.byteCodeProvider = byteCodeProvider;
		this.useByteCodeProviderForInterfaces = useByteCodeProviderForInterfaces;
	}
	
	public Object generateProxy(Class[] interfaces, SessionFactory sessionFactory, Class domainClass, Object target, Object [] delegates){
		if (target==null){
			if (!useByteCodeProviderForInterfaces){
				// TODO cache this too
				byteCodeProvider = new ReflectionProxyProvider();
			}
		}
		if (byteCodeProvider==null){
			byteCodeProvider = ByteCodeProviders.getInstance();
		}
		return byteCodeProvider.generateProxy(interfaces, sessionFactory, domainClass, target, delegates);
	}
}