package daobeauty.proxy.reflection;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

import org.hibernate.SessionFactory;

import daobeauty.interceptor.MethodInterceptor;

/**
 * Created 09.09.2008
 * @author M. Serhat Cinar
 *
 */
public class InvocationHandlerAdapter implements InvocationHandler {
	private MethodInterceptor generalInterceptor;
	
	public InvocationHandlerAdapter(SessionFactory sessionFactory, Class domainClass, Object target, Object [] delegates){
		generalInterceptor = new MethodInterceptor();
		generalInterceptor.setDelegates(delegates);
		generalInterceptor.setDomainClass(domainClass);
		generalInterceptor.setSessionFactory(sessionFactory);
		generalInterceptor.setTarget(target);
		generalInterceptor.initialize();
	}
	
	@SuppressWarnings("unused")
	public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
		return generalInterceptor.invoke(method, args);
	}
}
