package daobeauty.proxy.spring;

import org.aopalliance.intercept.MethodInterceptor;
import org.aopalliance.intercept.MethodInvocation;
import org.hibernate.SessionFactory;

import daobeauty.dao.SessionFactoryAware;

/**
 * Created 09.09.2008
 * @author M. Serhat Cinar
 *
 */
public class DaoBeautyInterceptor implements MethodInterceptor {
	private daobeauty.interceptor.MethodInterceptor generalMethodInterceptor;
	
	public DaoBeautyInterceptor(Class<? extends SessionFactoryAware> [] delegates, SessionFactory sessionFactory){
		generalMethodInterceptor = new daobeauty.interceptor.MethodInterceptor(sessionFactory, delegates);
	}
	
	/* (non-Javadoc)
	 * @see org.aopalliance.intercept.MethodInterceptor#invoke(org.aopalliance.intercept.MethodInvocation)
	 */
	public Object invoke(MethodInvocation arg0) throws Throwable {
		return generalMethodInterceptor.invoke(arg0.getThis(), arg0.getMethod(), arg0.getArguments());
	}

}
